summaryrefslogtreecommitdiffstats
path: root/.travis
diff options
context:
space:
mode:
authorPierre Ossman <ossman@cendio.se>2019-01-16 13:43:05 +0100
committerPierre Ossman <ossman@cendio.se>2019-01-21 16:35:22 +0100
commitdfccb170e6262ed278e955fa7e2907c71b4239da (patch)
treea0bb93d0a8728ce7098937c2e692ff26fb0a6961 /.travis
parent14b44869746f53bf97502e99f87a505cedf7684d (diff)
downloadtigervnc-dfccb170e6262ed278e955fa7e2907c71b4239da.tar.gz
tigervnc-dfccb170e6262ed278e955fa7e2907c71b4239da.zip
Build Ubuntu 14.04 (Trusty) packages in Travis
Diffstat (limited to '.travis')
-rw-r--r--.travis/trusty/Dockerfile11
-rwxr-xr-x.travis/trusty/build.sh65
2 files changed, 76 insertions, 0 deletions
diff --git a/.travis/trusty/Dockerfile b/.travis/trusty/Dockerfile
new file mode 100644
index 00000000..0a41647b
--- /dev/null
+++ b/.travis/trusty/Dockerfile
@@ -0,0 +1,11 @@
+FROM ubuntu:trusty
+
+RUN apt-get update
+RUN apt-get -y install packaging-dev equivs
+
+RUN useradd -s /bin/bash -m deb
+RUN echo >> /etc/sudoers
+RUN echo "deb ALL=(ALL) NOPASSWD:ALL" >> /etc/sudoers
+
+USER deb
+WORKDIR /home/deb
diff --git a/.travis/trusty/build.sh b/.travis/trusty/build.sh
new file mode 100755
index 00000000..08076da3
--- /dev/null
+++ b/.travis/trusty/build.sh
@@ -0,0 +1,65 @@
+#!/bin/bash
+
+set -e
+set -x
+
+## Basic variables
+
+CURDIR=$(dirname $(readlink -f $0))
+TOPDIR=$(git rev-parse --show-toplevel 2>/dev/null)
+
+DEBDIR=${TOPDIR}/contrib/packages/deb/ubuntu-trusty
+
+VERSION=$(grep '^set(VERSION ' ${TOPDIR}/CMakeLists.txt | sed 's@^set(VERSION \(.*\))@\1@')
+
+## Prepare the build directory
+
+rm -rf ${CURDIR}/build
+mkdir -p ${CURDIR}/build
+chmod a+w ${CURDIR}/build
+[ -x /usr/sbin/selinuxenabled ] && /usr/sbin/selinuxenabled && chcon -Rt container_file_t ${CURDIR}/build
+
+## Copy over the source code
+
+(cd ${TOPDIR} && git archive --prefix tigervnc-${VERSION}/ HEAD) | xz > ${CURDIR}/build/tigervnc-${VERSION}.tar.xz
+
+# Extra dependencies built because the distribution lacks what we need
+
+curl -L -o ${CURDIR}/build/fltk-1.3.4-2-source.tar.gz https://www.fltk.org/pub/fltk/1.3.4/fltk-1.3.4-2-source.tar.gz
+
+# Bundle up everything
+
+tar -C ${CURDIR}/build -axf ${CURDIR}/build/tigervnc-${VERSION}.tar.xz
+tar -C ${CURDIR}/build/tigervnc-${VERSION} -axf ${CURDIR}/build/fltk-1.3.4-2-source.tar.gz
+tar -C ${CURDIR}/build -acf ${CURDIR}/build/tigervnc_${VERSION}.orig.tar.xz tigervnc-${VERSION}
+rm -rf ${CURDIR}/build/tigervnc-${VERSION}
+
+## Copy over the packaging files
+
+cp -r ${DEBDIR}/debian ${CURDIR}/build/debian
+
+chmod a+x ${CURDIR}/build/debian/rules
+
+# Assemble a fake changelog entry to get the correct version
+
+cat - > ${CURDIR}/build/debian/changelog << EOT
+tigervnc (${VERSION}-1ubuntu1) UNRELEASED; urgency=low
+
+ * Automated build for TigerVNC
+
+ -- Build bot <tigervncbot@tigervnc.org> $(date -R)
+
+EOT
+cat ${DEBDIR}/debian/changelog >> ${CURDIR}/build/debian/changelog
+
+## Start the build
+
+docker run --volume ${CURDIR}/build:/home/deb/build --interactive --tty --rm tigervnc/${DOCKER} \
+ bash -c "
+ tar -C ~/build -axf ~/build/tigervnc_${VERSION}.orig.tar.xz &&
+ cp -a ~/build/debian ~/build/tigervnc-${VERSION}/debian &&
+ mk-build-deps ~/build/tigervnc-${VERSION}/debian/control &&
+ sudo dpkg --unpack ~/tigervnc-build-deps_*.deb &&
+ sudo apt-get -f install -y &&
+ cd ~/build/tigervnc-${VERSION} && dpkg-buildpackage
+ "